博客
关于我
强烈建议你试试无所不能的chatGPT,快点击我
hdu5389 Zero Escape
阅读量:4634 次
发布时间:2019-06-09

本文共 3184 字,大约阅读时间需要 10 分钟。

Problem Description
Zero Escape, is a visual novel adventure video game directed by Kotaro Uchikoshi (you may hear about ever17?) and developed by Chunsoft.
Stilwell is enjoying the first chapter of this series, and in this chapter digital root is an important factor. 
This is the definition of digital root on Wikipedia:
The digital root of a non-negative integer is the single digit value obtained by an iterative process of summing digits, on each iteration using the result from the previous iteration to compute a digit sum. The process continues until a single-digit number is reached.
For example, the digital root of 
65536 is 
7, because 
6+5+5+3+6=25 and 
2+5=7.
In the game, every player has a special identifier. Maybe two players have the same identifier, but they are different players. If a group of players want to get into a door numbered 
X(1X9), the digital root of their identifier sum must be 
X.
For example, players 
{
1,2,6}
 can get into the door 
9, but players 
{
2,3,3}
 can't.
There is two doors, numbered 
A and 
B. Maybe 
A=B, but they are two different door.
And there is 
n players, everyone must get into one of these two doors. Some players will get into the door 
A, and others will get into the door 
B.
For example: 
players are 
{
1,2,6}
A=9
B=1
There is only one way to distribute the players: all players get into the door 
9. Because there is no player to get into the door 
1, the digital root limit of this door will be ignored.
Given the identifier of every player, please calculate how many kinds of methods are there, 
mod 258280327.
 

Input
The first line of the input contains a single number 
T, the number of test cases.
For each test case, the first line contains three integers 
n
A and 
B.
Next line contains 
n integers 
idi, describing the identifier of every player.
T100
n105
n106
1A,B,idi9
 

Output
For each test case, output a single integer in a single line, the number of ways that these 
n players can get into these two doors.
 

Sample Input
 
4 3 9 1 1 2 6 3 9 1 2 3 3 5 2 3 1 1 1 1 1 9 9 9

1 2 3 4 5 6 7 8 9

这题关键是要发现定义的运算,起结果和该数%9的结果是一样的,然后能够开个数组dp[i][j](j属于0~8)表示前i个数能选出的数的和%9后为j的方案数。然后dp[i][j]=dp[i-1][j]以及dp[i][(j+c[i]%9)%9]=(dp[i][(j+c[i]%9)%9]+dp[i-1][j])%258280327。dp[]的过程中相当于把9当做0。注意dp的初始化。不然会出错。

#include
#include
#include
#include
#include
#include
#include
#include
#include
#include
#include
#include
using namespace std;#define ll long longint c[100060];int dp[1000060][10];int main(){ int n,m,i,j,T,a,b,sum,t1,t2,t,ans; scanf("%d",&T); while(T--) { scanf("%d%d%d",&n,&a,&b); sum=0; for(i=1;i<=n;i++){ scanf("%d",&c[i]); sum+=c[i]; } if(sum%9!=(a%9+b%9)%9 && sum%9!=a%9 && sum%9!=b%9){ printf("0\n");continue; } t1=a%9;t2=b%9;t=sum%9; dp[0][0]=1; for(i=1;i<=n;i++){ for(j=0;j<=8;j++){ dp[i][j]=dp[i-1][j]; } for(j=0;j<=8;j++){ dp[i][(j+c[i]%9)%9]=(dp[i][(j+c[i]%9)%9]+dp[i-1][j])%258280327; } } if((t1+t2)%9!=t){ if(t1==t && t2==t){ printf("2\n");continue; } printf("1\n");continue; } printf("%d\n",dp[n][a%9]); } return 0;}

转载于:https://www.cnblogs.com/llguanli/p/7304905.html

你可能感兴趣的文章
中国互联网的十一种盈利模式
查看>>
php中$_REQUEST、$_POST、$_GET的区别和联系小结
查看>>
看了极光推送技术原理的几点思考
查看>>
【转】Vue.js 2.0 快速上手精华梳理
查看>>
【题解】BZOJ 3065: 带插入区间K小值——替罪羊树套线段树
查看>>
OpenCV矩阵运算
查看>>
CF 567D(One-Dimensional Battle Ships-二分)
查看>>
从设计到实现,一步步教你实现Android-Universal-ImageLoader-辅助类
查看>>
redis 安装启动及设置密码windows
查看>>
python 生成验证码
查看>>
从零开始用 Flask 搭建一个网站(二)
查看>>
leetcode-93-复原ip地址
查看>>
RAID详解[RAID0/RAID1/RAID10/RAID5]
查看>>
MySQL 基础内容
查看>>
导航条——收缩式导航菜单
查看>>
经常使用ARM汇编指令
查看>>
函数指针&amp;绑定: boost::functoin/std::function/bind
查看>>
js实现双击后网页自己主动跑-------Day55
查看>>
TMS320F28335项目开发记录2_CCS与JTAG仿真器连接问题汇总
查看>>
PS多形式的部分之间复制“笨办法”
查看>>